diff --git a/target-i386/cpu.c b/target-i386/cpu.c
index ddae932ee1b4..66bd9d0c4039 100644
--- a/target-i386/cpu.c
+++ b/target-i386/cpu.c
@@ -506,7 +506,7 @@ const char *get_register_name_32(unsigned int reg)
  * Returns the set of feature flags that are supported and migratable by
  * QEMU, for a given FeatureWord.
  */
-static uint32_t x86_cpu_get_migratable_flags(FeatureWord w)
+static uint32_t x86_cpu_get_migratable_flags(FeatureWord w, bool is_amd)
 {
     FeatureWordInfo *wi = &feature_word_info[w];
     uint32_t r = 0;
@@ -514,12 +514,18 @@ static uint32_t x86_cpu_get_migratable_flags(FeatureWord w)
 
     for (i = 0; i < 32; i++) {
         uint32_t f = 1U << i;
+        FeatureWordInfo *effective_wi = wi;
+
+        if (is_amd && w == FEAT_8000_0001_EDX && f & CPUID_EXT2_AMD_ALIASES) {
+            effective_wi = &feature_word_info[FEAT_1_EDX];
+        }
+
         /* If the feature name is unknown, it is not supported by QEMU yet */
-        if (!wi->feat_names[i]) {
+        if (!effective_wi->feat_names[i]) {
             continue;
         }
         /* Skip features known to QEMU, but explicitly marked as unmigratable */
-        if (wi->unmigratable_flags & f) {
+        if (effective_wi->unmigratable_flags & f) {
             continue;
         }
         r |= f;
@@ -1423,8 +1429,7 @@ void x86_cpu_change_kvm_default(const char *prop, const char *value)
     assert(pv->prop);
 }
 
-static uint32_t x86_cpu_get_supported_feature_word(FeatureWord w,
-                                                   bool migratable_only);
+static uint32_t x86_cpu_get_supported_feature_word(FeatureWord w, X86CPU *cpu);
 
 #ifdef CONFIG_KVM
 
@@ -1974,7 +1979,7 @@ static void x86_cpu_parse_featurestr(CPUState *cs, char *features,
     if (cpu->host_features) {
         for (w = 0; w < FEATURE_WORDS; w++) {
             env->features[w] =
-                x86_cpu_get_supported_feature_word(w, cpu->migratable);
+                x86_cpu_get_supported_feature_word(w, cpu);
         }
     }
 
@@ -2050,8 +2055,14 @@ CpuDefinitionInfoList *arch_query_cpu_definitions(Error **errp)
     return cpu_list;
 }
 
-static uint32_t x86_cpu_get_supported_feature_word(FeatureWord w,
-                                                   bool migratable_only)
+#define IS_INTEL_CPU(env) ((env)->cpuid_vendor1 == CPUID_VENDOR_INTEL_1 && \
+                           (env)->cpuid_vendor2 == CPUID_VENDOR_INTEL_2 && \
+                           (env)->cpuid_vendor3 == CPUID_VENDOR_INTEL_3)
+#define IS_AMD_CPU(env) ((env)->cpuid_vendor1 == CPUID_VENDOR_AMD_1 && \
+                         (env)->cpuid_vendor2 == CPUID_VENDOR_AMD_2 && \
+                         (env)->cpuid_vendor3 == CPUID_VENDOR_AMD_3)
+
+static uint32_t x86_cpu_get_supported_feature_word(FeatureWord w, X86CPU *cpu)
 {
     FeatureWordInfo *wi = &feature_word_info[w];
     uint32_t r;
@@ -2065,8 +2076,8 @@ static uint32_t x86_cpu_get_supported_feature_word(FeatureWord w,
     } else {
         return ~0;
     }
-    if (migratable_only) {
-        r &= x86_cpu_get_migratable_flags(w);
+    if (cpu->migratable) {
+        r &= x86_cpu_get_migratable_flags(w, IS_AMD_CPU(&cpu->env));
     }
     return r;
 }
@@ -2084,7 +2095,7 @@ static int x86_cpu_filter_features(X86CPU *cpu)
 
     for (w = 0; w < FEATURE_WORDS; w++) {
         uint32_t host_feat =
-            x86_cpu_get_supported_feature_word(w, cpu->migratable);
+            x86_cpu_get_supported_feature_word(w, cpu);
         uint32_t requested_features = env->features[w];
         env->features[w] &= host_feat;
         cpu->filtered_features[w] = requested_features & ~env->features[w];
@@ -2872,13 +2883,6 @@ static void x86_cpu_apic_realize(X86CPU *cpu, Error **errp)
 }
 #endif
 
-
-#define IS_INTEL_CPU(env) ((env)->cpuid_vendor1 == CPUID_VENDOR_INTEL_1 && \
-                           (env)->cpuid_vendor2 == CPUID_VENDOR_INTEL_2 && \
-                           (env)->cpuid_vendor3 == CPUID_VENDOR_INTEL_3)
-#define IS_AMD_CPU(env) ((env)->cpuid_vendor1 == CPUID_VENDOR_AMD_1 && \
-                         (env)->cpuid_vendor2 == CPUID_VENDOR_AMD_2 && \
-                         (env)->cpuid_vendor3 == CPUID_VENDOR_AMD_3)
 static void x86_cpu_realizefn(DeviceState *dev, Error **errp)
 {
     CPUState *cs = CPU(dev);